﻿Imports System.Web.Mvc
Imports HowDoICodeFirst.FluentRelationships.Models

Namespace CodeFirstMVC.FluentRelationships.Controllers
	Public Class PostController
		Inherits Controller
		Private db As New BlogContext()


		Public Function Index(ByVal blogId As Integer) As ActionResult
			ViewBag.BlogId = blogId
			Return View(db.Posts.Where(Function(p) p.Blog.Id=blogId))
		End Function

		'
		' GET: /Post/Details/5

		Public Function Details(ByVal id As Integer) As ActionResult
			Return View()
		End Function

		'
		' GET: /Post/Create

		Public Function Create(ByVal blogId As Integer) As ActionResult
			ViewBag.FKBlogId = blogId
			Return View()
		End Function

		'
		' POST: /Post/Create

		<HttpPost>
		Public Function Create(ByVal post As Post) As ActionResult
			Try
				db.Posts.Add(post)


				For Each validationResults In db.GetValidationErrors()
					For Each [error] In validationResults.ValidationErrors
						Debug.WriteLine([error].ErrorMessage)

					Next [error]
				Next validationResults

				db.Configuration.ValidateOnSaveEnabled = False
				db.SaveChanges()

				Return RedirectToAction("Index", New With {Key .blogId = post.FKBlogId})

			Catch
				Return View()
			End Try

		End Function

		'
		' GET: /Post/Edit/5

		Public Function Edit(ByVal id As Integer) As ActionResult
            Return View(db.Posts.Find(id))
		End Function

		'
		' POST: /Post/Edit/5

        <HttpPost()>
        Public Function Edit(ByVal id As Integer, ByVal post As Post) As ActionResult
            Try
                db.Entry(post).State = EntityState.Modified
                db.SaveChanges()

                Return RedirectToAction("Index", New With {Key .blogId = post.FKBlogId})
            Catch
                Return View()
            End Try
        End Function

		'
		' GET: /Post/Delete/5

		Public Function Delete(ByVal id As Integer) As ActionResult
			Return View(db.Posts.Find(id))
		End Function

		'
		' POST: /Post/Delete/5

		<HttpPost>
		Public Function Delete(ByVal post As Post) As ActionResult
			Try
				db.Entry(post).State = EntityState.Deleted
				db.SaveChanges()
				Return RedirectToAction("Index", New With {Key .blogId = Request.Form("FKBlogId")})

			Catch
				Return View()
			End Try
		End Function
	End Class
End Namespace
